//CODE HEM_ButtonOSC ******
int ledPin = 13;          //variable to represent LED Pin
int buttonPin = 12;       //variable for the button pin
int periodKnob = A0;    //variable for knob pin (A = analog in)
int delayTime;          //variable for the delay time
//unsigned int means the integer doesn't go negative, so it can be twice as big
unsigned int delayMax;  //variable for max delay time

void setup() {
  pinMode(ledPin, OUTPUT); //configure pin 13 as an output
  //INPUT_PULLUP sets the pin high. It gets pulled "low" by
  //connecting it to ground through a button
  pinMode(buttonPin, INPUT_PULLUP);
}

void loop() {
  //check the button. It will be low if pressed
  //If the button is pressed, execute the oscillator code:
  if (digitalRead(buttonPin) == LOW) {
    //set delay time equal to the current value read on analog pin 0
    delayTime = analogRead(periodKnob);

    //map the analog read range from 0 - 1023 to 10000 to 1
    delayTime = map(delayTime, 0, 1023, 10000, 1);

    digitalWrite(ledPin, HIGH);
    delayMicroseconds(delayTime); //shorter delay
    digitalWrite(ledPin, LOW);
    delayMicroseconds(delayTime);
  }

  else {
    //if the button is not pressed, execute the noise oscillator
    delayMax = analogRead(periodKnob);  //set delayMax to current knob reading
    //map delayMax from 0 - 1023 range to 0 - 30000 range
    delayMax = map(delayMax, 0, 1023, 20, 30000);
    digitalWrite(ledPin, HIGH);   //toggle pin 13 to +5V
    //Pause the sketch for a random number of
    //microseconds between 0 and delayMax
    delayMicroseconds(random(delayMax));
    digitalWrite(ledPin, LOW);
    delayMicroseconds(random(delayMax));
  }

}
//**********END OF CODE
