//CODE HEM_ToneQUANTIZER******
const int tonePin = 13;      //create a variable to represent LED Pin
const byte buttonPin = 12;   //add variable for the button pin
const byte volLED = 10;      //add variable for the Volume LED
const byte noteKnob = A0;  //add variable for knob pin (A = analog in)
const byte scaleKnob = A1;  //add variable for knob pin (A = analog in)
int knobVal;        //create a variable for the delay time
int scaleType;      //create a variable to store the desired scale
int fadeVal = 0;      //create a variable to store the brightness of the LED

int degreeIndex;
byte octave = 3; //can be made variable by adding a knob
byte root = 6;  //can be made variable by adding a knob (0 = B, 1 = C, 2 = C#, 3 = D ... 6 = F, etc)
int i;  //variable to represent index of array

const int chromaticScale[89] = {31, 33, 35, 37, 39, 41, 44, 46, 49, 52, 55, 58, 62, 65, 69, 73, 78, 82, 87, 93, 98, 104, 110, 117, 123, 131, 139, 147, 156, 165, 175, 185, 196, 208, 220, 233, 247, 262, 277, 294, 311, 330, 349, 370, 392, 415, 440, 466, 494, 523, 554, 587, 622, 659, 698, 740, 784, 831, 880, 932, 988, 1047, 1109, 1175, 1245, 1319, 1297, 1480, 1568, 1661, 1760, 1865, 1976, 2093, 2217, 2349, 2489, 2637, 2794, 2960, 3136, 3322, 3520, 3729, 3951, 4186, 4435, 4699, 4978};

const byte chromaticMask[14] = {0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13};
const byte majorMask[8] = {0, 2, 4, 5, 7, 9, 11, 12};
const byte minorMask[8] = {0, 2, 3, 5, 7, 8, 10, 12};
const byte majorPentatonicMask[6] = {0, 2, 4, 7, 9, 12};
const byte minorPentatonicMask[6] = {0, 3, 5, 7, 10, 12};

const byte tonicMask[] = {0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11};
const byte octaveMask[] = {0, 12, 24, 36, 48, 60};
byte pitchNum;   //variable to store the index of the note array
int note = 0;

void setup() {
  pinMode(tonePin, OUTPUT); //configure pin 13 as an output
  //INPUT_PULLUP sets the pin high. It gets pulled "low" by
  //connecting it to ground through a button
  pinMode(buttonPin, INPUT_PULLUP);
}

void loop() {
  //set variable knobVal equal to the current value read on analog pin 0
  knobVal = analogRead(noteKnob);
  scaleType = analogRead(scaleKnob);

  int scale = map(scaleType, 0, 1023, 0, 4);

  if (scale == 0) {
    i = map(knobVal, 0, 1023, 0, 12);
    degreeIndex = chromaticMask[i];
    pitchNum = octaveMask[octave] + degreeIndex + tonicMask[root];
    note = chromaticScale[pitchNum];
  }

  if (scale == 1) { //B Major Scale
    i = map(knobVal, 0, 1023, 0, 7);
    degreeIndex = majorMask[i];
    pitchNum = octaveMask[octave] + degreeIndex + tonicMask[root];
    note = chromaticScale[pitchNum];
  }

  if (scale == 2) {
    i = map(knobVal, 0, 1023, 0, 7);
    degreeIndex = minorMask[i];
    pitchNum = octaveMask[octave] + degreeIndex + tonicMask[root];
    note = chromaticScale[pitchNum];
  }

  if (scale == 3) {
    i = map(knobVal, 0, 1023, 0, 5);
    degreeIndex = majorPentatonicMask[i];
    pitchNum = octaveMask[octave] + degreeIndex + tonicMask[root];
    note = chromaticScale[pitchNum];
  }

  if (scale == 4) {
    i = map(knobVal, 0, 1023, 0, 5);
    degreeIndex = minorPentatonicMask[i];
    pitchNum = octaveMask[octave] + degreeIndex + tonicMask[root];
    note = chromaticScale[pitchNum];
  }

  //check the button. It will be LOW if pressed
  //If the button is pressed, write fade value to the LED:
  if (digitalRead(buttonPin) == LOW) {
    tone(tonePin, note);
    analogWrite(volLED, 255); //turn the volume all the way on and play the note
  }

  else {
    //do nothing if button
    analogWrite(volLED, 0);
  }

}
//**********END OF CODE
