//CODE HEM_VolumeOSC ******
int tonePin = 13;      //create a variable to represent LED Pin
int buttonPin = 12;   //add variable for the button pin
int volLED = 10;      //add variable for the Volume LED
int periodKnob = A0;  //add variable for knob pin (A = analog in)
int volumeKnob = A1;  //add variable for knob pin (A = analog in)
int delayTime;        //create a variable for the delay time
int fadeVal = 0;      //create a variable to store the brightness of the LED

void setup() {
  pinMode(tonePin, OUTPUT); //configure pin 13 as an output
  //INPUT_PULLUP sets the pin high. It gets pulled "low" by
  //connecting it to ground through a button
  pinMode(buttonPin, INPUT_PULLUP);
}

void loop() {
  //set delay time equal to the current value read on analog pin 0
  delayTime = analogRead(periodKnob);
  
  //map the analog read range from 0 - 1023 to 10000 to 1
  delayTime = map(delayTime, 0, 1023, 10000, 1);
  
  digitalWrite(tonePin, HIGH);
  delayMicroseconds(delayTime);
  digitalWrite(tonePin, LOW);
  delayMicroseconds(delayTime);

  //check the button. It will be LOW if pressed
  //If the button is pressed, write fade value to the LED:
  if (digitalRead(buttonPin) == LOW) {
    //read the fade knob and scale the range from
    //10bits (0 - 1023) to 8 bits (0 - 255)
    //analogRead is 10 bits
    //analogWrite is 8 bits
    //1023 divided by 4 is 255 (faster than map())
    fadeVal = analogRead(volumeKnob) / 4;
    analogWrite(volLED, fadeVal);
  }

  else {
    //turn LED off if button not pressed
    analogWrite(volLED, 0);
  }

}
//**********END OF CODE
